import { LambdaColumnMetadata, LambdaExpressionMetadata } from "./metadatas";
import { Expression, LambdaExpression } from "./types";
export declare class ExpressionUtils {
    private _defaultSeparator;
    constructor(_defaultSeparator?: string);
    getValueByExpression<T>(instance: T, expression: Expression<T>): any;
    getValueByProperties(instance: any, properties: string[]): any;
    getValue(instance: any, property: string): any;
    getColumnByExpression<T>(expression: Expression<T>, separator?: string): string;
    getColumnByProperties(properties: string[], separator?: string): string;
    getPropertiesByExpression<T>(expression: Expression<T>): string[];
    private hasAlias(value, alias);
    private hasBetweenQuotes(value);
    private hasExpression(value, alias);
    getPropertiesByExpressionString(expression: string, alias?: string | undefined): string[];
    getColumnByLambdaExpression<T>(expression: LambdaExpression<T>): LambdaColumnMetadata;
    private getPropertiesByLambdaExpression<T>(expression);
    private getAlias(startExpression);
    getExpressionByLambdaExpression<T>(expression: LambdaExpression<T>): LambdaExpressionMetadata;
}
